import sys
from common import BinaryFile
import pickle

class MDLFile():
    def read(self, in_name):
        fin = BinaryFile(in_name, 'r')
        self.vertices = []
        self.normals = []
        self.faces = []

        self.tag = fin.read_u32()
        if self.tag != 0x04B40000:
            print("Invalid MDL file")
            sys.exit()

        fin.seek(0x48, 0)
        vertex_offset = fin.read_u32()
        normal_offset = fin.read_u32()
        unknown_offset = fin.read_u32()

        vtx_size = normal_offset - vertex_offset
        nml_size = unknown_offset = normal_offset

        # print(vtx_size / 4)
        # print(nml_size / 4)

        fin.seek(0x30 + vertex_offset, 0)
        self.nverts = 0
        self.nnorms = 0

        fout = open('luige.obj', 'w')
        
        while vtx_size > 0:
            self.vertices.append([fin.read_f32(), fin.read_f32(), fin.read_f32()])
            fout.write('v ' + str(self.vertices[self.nverts][0]) + ' ' + str(self.vertices[self.nverts][1]) + ' ' + str(self.vertices[self.nverts][2]) + '\n')
            # print('Vertex ' + str(self.nverts))
            # print('X: ' + str(self.vertices[self.nverts][0]))
            # print('Y: ' + str(self.vertices[self.nverts][1]))
            # print('Z: ' + str(self.vertices[self.nverts][2]) + '\n')
            
            self.nverts += 1
            vtx_size -= 4

        fin.seek(0x30 + normal_offset, 0)
        while nml_size > 0:
            self.normals.append([fin.read_f32(), fin.read_f32(), fin.read_f32()])
            # print('Normals: ' + str(self.nnorms))
            self.nnorms += 1
            nml_size -= 4

        for i in range(1, self.nverts + 1):
            if i < (self.nverts - 1):
                fout.write('l ' + str(i) + ' ' + str(i + 1) + '\n')

        pickle.dump(self.vertices, open('vertices.txt', 'wb'))
    def __init__(self, in_name):
        self.read(in_name)

mdl = MDLFile(sys.argv[1])
